/*--------------------------------------------------------------------------*/
/*  (C) Copyright Monstein Radio Astronomy Support, Freienbach Switzerland  */
/*--------------------------------------------------------------------------*/
/*  Programmname: Clinors232.cpp                                            */
/*                                                                          */
/*  Revision: V1.0     Date: 15.06.2003    Autor: Chr. Monstein             */
/*                                                                          */
/*  Purpose: RS232 control unit for Relaiskarte                             */
/*                                                                          */
/*  Compiler: BORLAND C++Builder 6                                          */
/*--------------------------------------------------------------------------*/

// Created by: Chr. Monstein 15.06.2004
// Updated by: Chr. Monstein 23.09.2022

//---------------------------------------------------------------------------
#define WIN32
#include <vcl.h>
#pragma hdrstop
#include "WSC.H"
#include "ClinoRS232.h"
#include "mainunit.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------

TWrite *Clino_SerialThread;
char comport[40];
int Port; // = COM1...8
int Baud = WSC_Baud9600; //   static...

char ringbuff[buflen];
int in=0, out=0;

//---------------------------------------------------------------------------
__fastcall TWrite::TWrite(bool CreateSuspended) : TThread(CreateSuspended)
{
}
//---------------------------------------------------------------------------
void __fastcall TWrite::Init(void)
{
    char Temp[80];
    int Code;
    if (strstr(comport,"COM1")) Port=COM1;
    if (strstr(comport,"COM2")) Port=COM2;
    if (strstr(comport,"COM3")) Port=COM3;
    if (strstr(comport,"COM4")) Port=COM4;
    if (strstr(comport,"COM5")) Port=COM5;
    if (strstr(comport,"COM6")) Port=COM6;
    if (strstr(comport,"COM7")) Port=COM7;
    if (strstr(comport,"COM8")) Port=COM8;
    if (strstr(comport,"COM9")) Port=COM9;
    if (strstr(comport,"COM10")) Port=COM10;
    if (strstr(comport,"COM11")) Port=COM11;
    if (strstr(comport,"COM12")) Port=COM12;
    if (strstr(comport,"COM13")) Port=COM13;
    if (strstr(comport,"COM14")) Port=COM14;
    if (strstr(comport,"COM15")) Port=COM15;

    // Code = SioDebug('R'); // power USB-device
    Code = SioReset(Port,8192,1024); // COM, RX-buffer, TX-buffer
    if(Code<0)
    {
        SioWinError((LPSTR)Temp,80);
        MainForm->Label4->Caption = Temp;
    }
    else
    {
        SioParms(Port,WSC_NoParity,WSC_OneStopBit,WSC_WordLength8);
        SioBaud(Port,Baud);
        SioDTR(Port,'S');
        SioRTS(Port,'S');
        MainForm->Label4->Caption = "Relaiskarte on line";
    }
}
//---------------------------------------------------------------------------
void __fastcall TWrite::Transmit(char byte) // Send byte to client via RS
{
    SioPutc(Port, byte);
}
//---------------------------------------------------------------------------
void __fastcall TWrite::Send(char * cmd) // Send byte to client via RS
{
    SioPuts(Port, (LPSTR)cmd, strlen(cmd)); // string to receiver
}
//---------------------------------------------------------------------------
void __fastcall TWrite::GetClinoRS232Data(void) // Private activities
{
    int cnt;
    char buffer[512]; // we expect 4KByte/sec = 40Byte/10msec

    cnt=SioGets(Port,(LPSTR)buffer,512);  // (LPSTR) = mit null beendeter String
    for (int i=0; i<cnt; i++) // fill up ringbuffer
    {
        ringbuff[in]=buffer[i];
        in=(in+1)%buflen;
    }
}
//---------------------------------------------------------------------------
void __fastcall TWrite::Execute() // Main job extra-thread
{
    while(1) // almost forever...
    {
        if(Terminated) return; // exit thread
        GetClinoRS232Data();
        Sleep(10); // wait
    }
}
//---------------------------------------------------------------------------
void __fastcall TWrite::Close() // termination
{
    SioDone(Port);
    Terminate();
    WaitFor();
    //ShowMessage("RMS2m Thread terminated");
}
//---------------------------------------------------------------------------

